"use strict";var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports, "__esModule", { value: true });exports.default = exports.PATH_STATUS = void 0;var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));



var _client = _interopRequireDefault(require("../client"));function ownKeys(object, enumerableOnly) {var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {var symbols = Object.getOwnPropertySymbols(object);enumerableOnly && (symbols = symbols.filter(function (sym) {return Object.getOwnPropertyDescriptor(object, sym).enumerable;})), keys.push.apply(keys, symbols);}return keys;}function _objectSpread(target) {for (var i = 1; i < arguments.length; i++) {var source = null != arguments[i] ? arguments[i] : {};i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {(0, _defineProperty2.default)(target, key, source[key]);}) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));});}return target;} /**
 * Status api client to perform RQLite status and diagnostics operations
 * @module api/status
 */ /**
 * @typedef {Object} HttpResponse
 * @property {Object} Body The HTTP response body parsed by JSON.parse()
 * @property {Number} statusCode The HTTP response code
 */
/**
 * @typedef {Object} StatusAllHostsResponse
 * @property {HttpResponse} response An HTTP response
 * @property {String} host The host name
 */

/**
 * The RQLite status api path
 */
const PATH_STATUS = '/status';

/**
 * Data api client to perform RQLite queries
 */exports.PATH_STATUS = PATH_STATUS;
class StatusApiClient extends _client.default {
  /**
   * Get the RQLite server status which defaults to the master host
   * @param {Object} [options={}] RQLite api options
   * @returns {HttpResponse} An HTTP response object
   */
  status(options = {}) {var _superprop_getGet = () => super.get,_this = this;return (0, _asyncToGenerator2.default)(function* () {
      return _superprop_getGet().call(_this, PATH_STATUS, _objectSpread({ useLeader: true }, options));})();
  }

  /**
   * Get the RQLite server status for all hosts as an array of object with
   * the host and their status
   * @param {Object} [options={}] RQLite api options
   * @param {Object} [options.raw] If true return the raw http response from
   * RQLite response
   * @returns {StatusAllHostsResponse[]} An array of http response for the provide hosts
   */
  statusAllHosts(options = {}) {var _this2 = this;return (0, _asyncToGenerator2.default)(function* () {
      const hosts = _this2.getHosts();
      // Get the status for all of the hosts
      const promises = hosts.map( /*#__PURE__*/function () {var _ref = (0, _asyncToGenerator2.default)(function* (_host, activeHostIndex) {
          const response = yield _this2.status(_objectSpread(_objectSpread({}, options), {}, { activeHostIndex }));
          return { response, host: hosts[activeHostIndex] };
        });return function (_x, _x2) {return _ref.apply(this, arguments);};}());
      return Promise.all(promises);})();
  }
}exports.default = StatusApiClient;
//# sourceMappingURL=index.js.map